Index: channels/chan_modem_i4l.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem_i4l.c,v
retrieving revision 1.25
diff -u -r1.25 chan_modem_i4l.c
--- channels/chan_modem_i4l.c	21 Apr 2005 06:02:43 -0000	1.25
+++ channels/chan_modem_i4l.c	25 May 2005 21:09:33 -0000
@@ -36,6 +36,13 @@
 
 static char *desc = "ISDN4Linux Emulated Modem Driver";
 
+struct ast_modem *ast_modem;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_modem),
+        { NULL, NULL }
+};
+
+
 static int usecnt;
 AST_MUTEX_DEFINE_STATIC(usecnt_lock);
 
@@ -53,17 +60,17 @@
 		return -1;
 	} else	/* Convert DEV to our understanding of it */
 		dev = 2;
-	if (ast_modem_send(p, "AT+VLS?", 0)) {
+	if (ast_modem->send(p, "AT+VLS?", 0)) {
 		ast_log(LOG_WARNING, "Unable to select current mode %d\n", dev);
 		return -1;
 	}
-	if (ast_modem_read_response(p, 5)) {
+	if (ast_modem->read_response(p, 5)) {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	ast_modem_trim(p->response);
+	ast_modem->trim(p->response);
 	strncpy(cmd, p->response, sizeof(cmd)-1);
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Modem did not respond properly\n");
 		return -1;
 	}
@@ -73,15 +80,15 @@
 		return 0;
 	}
 	snprintf(cmd, sizeof(cmd), "AT+VLS=%d", dev);
-	if (ast_modem_send(p, cmd, 0))  {
+	if (ast_modem->send(p, cmd, 0))  {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	if (ast_modem_read_response(p, 5)) {
+	if (ast_modem->read_response(p, 5)) {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	ast_modem_trim(p->response);
+	ast_modem->trim(p->response);
 	if (strcasecmp(p->response, "VCON") && strcasecmp(p->response, "OK")) {
 		ast_log(LOG_WARNING, "Unexpected reply: %s\n", p->response);
 		return -1;
@@ -91,8 +98,8 @@
 
 static int i4l_startrec(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, "AT+VRX+VTX", 0) ||
-	     ast_modem_expect(p, "CONNECT", 5)) {
+	if (ast_modem->send(p, "AT+VRX+VTX", 0) ||
+	     ast_modem->expect(p, "CONNECT", 5)) {
 		ast_log(LOG_WARNING, "Unable to start recording\n");
 		return -1;
 	}
@@ -117,31 +124,31 @@
 
 static int i4l_break(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, breakcmd, 2)) {
+	if (ast_modem->send(p, breakcmd, 2)) {
 		ast_log(LOG_WARNING, "Failed to break\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "\r\n", 2)) {
+	if (ast_modem->send(p, "\r\n", 2)) {
 		ast_log(LOG_WARNING, "Failed to send enter?\n");
 		return -1;
 	}
 #if 0
 	/* Read any outstanding junk */
-	while(!ast_modem_read_response(p, 1));
+	while(!ast_modem->read_response(p, 1));
 #endif
-	if (ast_modem_send(p, "AT", 0)) {
+	if (ast_modem->send(p, "AT", 0)) {
 		/* Modem might be stuck in some weird mode, try to get it out */
-		ast_modem_send(p, "+++", 3);
-		if (ast_modem_expect(p, "OK", 10)) {
+		ast_modem->send(p, "+++", 3);
+		if (ast_modem->expect(p, "OK", 10)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
-		if (ast_modem_send(p, "AT", 0)) {
+		if (ast_modem->send(p, "AT", 0)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
 	}
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Modem did not respond properly\n");
 		return -1;
 	}
@@ -157,15 +164,15 @@
 		return -1;
 	/* Force into command mode */
 	p->ministate = STATE_COMMAND;
-	if (ast_modem_send(p, "AT+FCLASS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+FCLASS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to voice mode\n");
 		return -1;
 	}
 	if (strlen(p->msn)) {
 		snprintf(cmd, sizeof(cmd), "AT&E%s", p->msn);
-		if (ast_modem_send(p, cmd, 0) ||
-		    ast_modem_expect(p, "OK", 5)) {
+		if (ast_modem->send(p, cmd, 0) ||
+		    ast_modem->expect(p, "OK", 5)) {
 			ast_log(LOG_WARNING, "Unable to set MSN to %s\n", p->msn);
 			return -1;
 		}
@@ -180,45 +187,45 @@
 			if (*q == ',') *q = ';';
 			++q;
 		}
-		if (ast_modem_send(p, cmd, 0) ||
-		    ast_modem_expect(p, "OK", 5)) {
+		if (ast_modem->send(p, cmd, 0) ||
+		    ast_modem->expect(p, "OK", 5)) {
 			ast_log(LOG_WARNING, "Unable to set Listen to %s\n", p->msn);
 			return -1;
 		}
 	}
-	if (ast_modem_send(p, "AT&D2", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT&D2", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to DTR disconnect mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "ATS18=1", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "ATS18=1", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to audio only mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "ATS13.6=1", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "ATS13.6=1", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to RUNG indication\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "ATS14=4", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "ATS14=4", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to transparent mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "ATS23=9", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "ATS23=9", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to transparent/ringing mode\n");
 		return -1;
 	}
 
-	if (ast_modem_send(p, "AT+VSM=6", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VSM=6", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to muLAW mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VLS=2", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VLS=2", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to phone line interface\n");
 		return -1;
 	}
@@ -265,7 +272,7 @@
 		return &p->fr;
 	case 'o': /* Overrun */
 		ast_log(LOG_WARNING, "Overflow on modem, flushing buffers\n");
-		if (ast_modem_send(p, "\0x10E", 2)) 
+		if (ast_modem->send(p, "\0x10E", 2)) 
 			ast_log(LOG_WARNING, "Unable to flush buffers\n");
 		return &p->fr;	
 	case CHAR_ETX: /* End Transmission */
@@ -335,7 +342,7 @@
 				return i4l_handle_escape(p, 0);
 			/* Read the rest of the line */
 			fgets(result + 2, sizeof(result) - 2, p->f);
-			ast_modem_trim(result);
+			ast_modem->trim(result);
 			if (!strcasecmp(result, "VCON")) {
 				/* If we're in immediate mode, reply now */
 /*				if (p->mode == MODEM_MODE_IMMEDIATE) */
@@ -550,20 +557,20 @@
 
 static int i4l_answer(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, "ATA\r", 4) ||
-	     ast_modem_expect(p, "VCON", 10)) {
+	if (ast_modem->send(p, "ATA\r", 4) ||
+	     ast_modem->expect(p, "VCON", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
 #if 1
-	if (ast_modem_send(p, "AT+VDD=0,8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VDD=0,8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to phone line interface\n");
 		return -1;
 	}
 #endif
-	if (ast_modem_send(p, "AT+VTX+VRX", 0) ||
-	     ast_modem_expect(p, "CONNECT", 10)) {
+	if (ast_modem->send(p, "AT+VTX+VRX", 0) ||
+	     ast_modem->expect(p, "CONNECT", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
@@ -617,7 +624,7 @@
 	    if(strlen(p->outgoingmsn) && strstr(p->outgoingmsn,tmpmsn) != NULL) {
 	      /* Tell ISDN4Linux to use this as A number */
 	      snprintf(cmd, sizeof(cmd), "AT&E%s\n", c->cid.cid_num);
-	      if (ast_modem_send(p, cmd, strlen(cmd))) {
+	      if (ast_modem->send(p, cmd, strlen(cmd))) {
 		ast_log(LOG_WARNING, "Unable to set A number to %s\n", c->cid.cid_num);
 	      }
 
@@ -627,7 +634,7 @@
 	}
 
 	snprintf(cmd, sizeof(cmd), "ATD%c %s\n", p->dialtype,stuff);
-	if (ast_modem_send(p, cmd, strlen(cmd))) {
+	if (ast_modem->send(p, cmd, strlen(cmd))) {
 		ast_log(LOG_WARNING, "Unable to dial\n");
 		return -1;
 	}
@@ -659,11 +666,11 @@
 	/* basically we're done, just to be sure */
 	write(p->fd, "\n\n", 2);
 	read(p->fd, dummy, sizeof(dummy));
-	if (ast_modem_send(p, "ATH", 0)) {
+	if (ast_modem->send(p, "ATH", 0)) {
 		ast_log(LOG_WARNING, "Unable to hang up\n");
 		return -1;
 	}
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Final 'OK' not received\n");
 		return -1;
 	}
@@ -708,12 +715,12 @@
 
 int load_module(void)
 {
-	return ast_register_modem_driver(&i4l_driver);
+	return ast_modem->register_driver(&i4l_driver);
 }
 
 int unload_module(void)
 {
-	return ast_unregister_modem_driver(&i4l_driver);
+	return ast_modem->unregister_driver(&i4l_driver);
 }
 
 char *description()
Index: channels/chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.739
diff -u -r1.739 chan_sip.c
--- channels/chan_sip.c	20 May 2005 03:14:41 -0000	1.739
+++ channels/chan_sip.c	25 May 2005 21:09:45 -0000
@@ -110,6 +110,12 @@
 #define DEBUG_READ	0			/* Recieved data	*/
 #define DEBUG_SEND	1			/* Transmit data	*/
 
+static struct	ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+	MOD_WANT(ast_features),
+	{NULL, NULL}
+};
+
 static const char desc[] = "Session Initiation Protocol (SIP)";
 static const char channeltype[] = "SIP";
 static const char config[] = "sip.conf";
@@ -5617,14 +5623,14 @@
 	if (sip_debug_test_pvt(p))
 		ast_verbose("Looking for %s in %s\n", c, p->context);
 	if (ast_exists_extension(NULL, p->context, c, 1, fr) ||
-		!strcmp(c, ast_pickup_ext())) {
+		!strcmp(c, ast_features->ast_pickup_ext())) {
 		if (!oreq)
 			ast_copy_string(p->exten, c, sizeof(p->exten));
 		return 0;
 	}
 
 	if (ast_canmatch_extension(NULL, p->context, c, 1, fr) ||
-	    !strncmp(c, ast_pickup_ext(),strlen(c))) {
+	    !strncmp(c, ast_features->ast_pickup_ext(),strlen(c))) {
 		return 1;
 	}
 	
@@ -5797,7 +5803,7 @@
 	    		  INVITE with a replaces header -anthm XXX */
 			/* The only way to find out is to use the dialplan - oej */
 		}
-	} else if (ast_exists_extension(NULL, sip_pvt->context, refer_to, 1, NULL) || !strcmp(refer_to, ast_parking_ext())) {
+	} else if (ast_exists_extension(NULL, sip_pvt->context, refer_to, 1, NULL) || !strcmp(refer_to, ast_features->ast_parking_ext())) {
 		/* This is an unsupervised transfer (blind transfer) */
 		
 		ast_log(LOG_DEBUG,"Unsupervised transfer to (Refer-To): %s\n", refer_to);
@@ -8471,7 +8477,7 @@
 	ast_mutex_lock(&chan1->lock);
 	ast_do_masquerade(chan1);
 	ast_mutex_unlock(&chan1->lock);
-	res = ast_park_call(chan1, chan2, 0, &ext);
+	res = ast_features->ast_park_call(chan1, chan2, 0, &ext);
 	/* Then hangup */
 	ast_hangup(chan2);
 	ast_log(LOG_DEBUG, "Parked on extension '%d'\n", ext);
@@ -8780,7 +8786,7 @@
 		case AST_STATE_DOWN:
 			transmit_response(p, "100 Trying", req);
 			ast_setstate(c, AST_STATE_RING);
-			if (strcmp(p->exten, ast_pickup_ext())) {
+			if (strcmp(p->exten, ast_features->ast_pickup_ext())) {
 				if (ast_pbx_start(c)) {
 					ast_log(LOG_WARNING, "Failed to start PBX :(\n");
 					/* Unlock locks so ast_hangup can do its magic */
@@ -8796,7 +8802,7 @@
 				}
 			} else {
 				ast_mutex_unlock(&c->lock);
-				if (ast_pickup_call(c)) {
+				if (ast_features->ast_pickup_call(c)) {
 					ast_log(LOG_NOTICE, "Nothing to pick up\n");
 					if (ignore)
 						transmit_response(p, "503 Unavailable", req);
@@ -8886,7 +8892,7 @@
 					if (transfer_to) {
 						ast_log(LOG_DEBUG, "Got SIP blind transfer, applying to '%s'\n", transfer_to->name);
 						ast_moh_stop(transfer_to);
-						if (!strcmp(p->refer_to, ast_parking_ext())) {
+						if (!strcmp(p->refer_to, ast_features->ast_parking_ext())) {
 							/* Must release c's lock now, because it will not longer
 							    be accessible after the transfer! */
 							*nounlock = 1;
Index: channels/chan_skinny.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_skinny.c,v
retrieving revision 1.73
diff -u -r1.73 chan_skinny.c
--- channels/chan_skinny.c	15 May 2005 03:21:51 -0000	1.73
+++ channels/chan_skinny.c	25 May 2005 21:09:48 -0000
@@ -52,6 +52,12 @@
 #include "asterisk/dsp.h"
 #include <ctype.h>
 
+static struct ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_features),
+        { NULL, NULL }
+};
+
 /************************************************************************************/
 /*                         Skinny/Asterisk Protocol Settings                        */
 /************************************************************************************/
@@ -1515,12 +1521,12 @@
             memset(exten, 0, sizeof(exten));
             timeout = firstdigittimeout;
                 
-        } else if (!strcmp(exten,ast_pickup_ext())) {
+        } else if (!strcmp(exten,ast_features->ast_pickup_ext())) {
             /* Scan all channels and see if any there
              * ringing channqels with that have call groups
              * that equal this channels pickup group  
              */
-            if (ast_pickup_call(chan)) {
+            if (ast_features->ast_pickup_call(chan)) {
                 ast_log(LOG_WARNING, "No call pickup possible...\n");
 				transmit_tone(s, SKINNY_REORDER);
             }
@@ -1588,12 +1594,12 @@
             getforward = 0;
             memset(exten, 0, sizeof(exten));
             len = 0;
-        } else if (!strcmp(exten, ast_parking_ext()) && 
+        } else if (!strcmp(exten, ast_features->ast_parking_ext()) && 
                     sub->next->owner &&
                     ast_bridged_channel(sub->next->owner)) {
             /* This is a three way call, the main call being a real channel, 
                 and we're parking the first call. */
-            ast_masq_park_call(ast_bridged_channel(sub->next->owner), chan, 0, NULL);
+            ast_features->ast_masq_park_call(ast_bridged_channel(sub->next->owner), chan, 0, NULL);
             if (option_verbose > 2) {
                 ast_verbose(VERBOSE_PREFIX_3 "Parking call to '%s'\n", chan->name);
             }
Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.448
diff -u -r1.448 chan_zap.c
--- channels/chan_zap.c	20 May 2005 19:09:21 -0000	1.448
+++ channels/chan_zap.c	25 May 2005 21:10:05 -0000
@@ -121,6 +121,12 @@
 #endif
 ;
 
+static struct ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_features),
+        { NULL, NULL }
+};
+
 static const char type[] = "Zap";
 static const char config[] = "zapata.conf";
 
@@ -267,6 +273,8 @@
 #ifdef PRI_GETSET_TIMERS
 static int pritimers[PRI_MAX_TIMERS];
 #endif
+static int pridebugfd = -1;
+static char pridebugfilename[1024]="";
 #endif
 
 /* Wait up to 16 seconds for first digit (FXO logic) */
@@ -288,8 +296,6 @@
 static int ifcount = 0;
 
 AST_MUTEX_DEFINE_STATIC(pridebugfdlock);
-static int pridebugfd = -1;
-static char pridebugfilename[1024]="";
 
 /* Whether we answer on a Polarity Switch event */
 static int answeronpolarityswitch = 0;
@@ -5195,7 +5201,7 @@
 				tone_zone_play_tone(p->subs[index].zfd, -1);
 			else
 				tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_DIALTONE);
-			if (ast_exists_extension(chan, chan->context, exten, 1, p->cid_num) && strcmp(exten, ast_parking_ext())) {
+			if (ast_exists_extension(chan, chan->context, exten, 1, p->cid_num) && strcmp(exten, ast_features->ast_parking_ext())) {
 				if (!res || !ast_matchmore_extension(chan, chan->context, exten, 1, p->cid_num)) {
 					if (getforward) {
 						/* Record this as the forwarding extension */
@@ -5260,7 +5266,7 @@
 				memset(exten, 0, sizeof(exten));
 				timeout = firstdigittimeout;
 					
-			} else if (!strcmp(exten,ast_pickup_ext())) {
+			} else if (!strcmp(exten,ast_features->ast_pickup_ext())) {
 				/* Scan all channels and see if any there
 				 * ringing channqels with that have call groups
 				 * that equal this channels pickup group  
@@ -5275,7 +5281,7 @@
 						unalloc_sub(p, SUB_THREEWAY);
 					}
 					zt_enable_ec(p);
-					if (ast_pickup_call(chan)) {
+					if (ast_features->ast_pickup_call(chan)) {
 						ast_log(LOG_DEBUG, "No call pickup possible...\n");
 						res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_CONGESTION);
 						zt_wait_event(p->subs[index].zfd);
@@ -5354,12 +5360,12 @@
 				getforward = 0;
 				memset(exten, 0, sizeof(exten));
 				len = 0;
-			} else if ((p->transfer || p->canpark) && !strcmp(exten, ast_parking_ext()) && 
+			} else if ((p->transfer || p->canpark) && !strcmp(exten, ast_features->ast_parking_ext()) && 
 						p->subs[SUB_THREEWAY].owner &&
 						ast_bridged_channel(p->subs[SUB_THREEWAY].owner)) {
 				/* This is a three way call, the main call being a real channel, 
 					and we're parking the first call. */
-				ast_masq_park_call(ast_bridged_channel(p->subs[SUB_THREEWAY].owner), chan, 0, NULL);
+				ast_features->ast_masq_park_call(ast_bridged_channel(p->subs[SUB_THREEWAY].owner), chan, 0, NULL);
 				if (option_verbose > 2)
 					ast_verbose(VERBOSE_PREFIX_3 "Parking call to '%s'\n", chan->name);
 				break;
Index: include/asterisk/adsi.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/adsi.h,v
retrieving revision 1.8
diff -u -r1.8 adsi.h
--- include/asterisk/adsi.h	21 Apr 2005 06:02:44 -0000	1.8
+++ include/asterisk/adsi.h	25 May 2005 21:10:15 -0000
@@ -110,6 +110,8 @@
 #define ADSI_DIR_FROM_LEFT (0)
 #define ADSI_DIR_FROM_RIGHT (1)
 
+struct adsi_services {
+#if 0
 /*! Perform Asterisk ADSI initialization (for channel drivers that want */
 /*    to support ADSI when the handset is first lifted) */ 
 /*! 
@@ -118,11 +120,12 @@
  * Returns 0 on success (or adsi unavailable) and -1 on hangup
  * 
  */
-extern int adsi_channel_init(struct ast_channel *chan);
+int (*channel_init)(struct ast_channel *chan);
+#endif
 
-extern int adsi_begin_download(struct ast_channel *chan, char *service, char *fdn, char *sec, int version);
+int (*begin_download)(struct ast_channel *chan, char *service, char *fdn, char *sec, int version);
 
-extern int adsi_end_download(struct ast_channel *chan);
+int (*end_download)(struct ast_channel *chan);
 
 /*! Restore ADSI initialization (for applications that play with ADSI */
 /*   and want to restore it to normal.  If you touch "INFO" then you */
@@ -133,7 +136,7 @@
  * Returns 0 on success (or adsi unavailable) and -1 on hangup
  *
  */
-extern int adsi_channel_restore(struct ast_channel *chan);
+int (*channel_restore)(struct ast_channel *chan);
 
 /*! Display some stuff on the screen */
 /*!
@@ -145,7 +148,7 @@
  * Return 0 on success (or adsi unavailable) and -1 on hangup
  *
  */
-extern int adsi_print(struct ast_channel *chan, char **lines, int *align, int voice);
+int (*print)(struct ast_channel *chan, char **lines, int *align, int voice);
 
 /*! Check if scripts for a given app are already loaded.  Version may be -1 */
 /*   if any version is okay, or 0-255 for a specific version. */
@@ -158,18 +161,21 @@
  * Returns 0 if scripts is not loaded or not an ADSI CPE.  Returns -1
  * on hangup.  Returns 1 if script already loaded.
  */
-extern int adsi_load_session(struct ast_channel *chan, unsigned char *app, int ver, int data);
-extern int adsi_unload_session(struct ast_channel *chan);
+int (*load_session)(struct ast_channel *chan, unsigned char *app, int ver, int data);
+int (*unload_session)(struct ast_channel *chan);
 
+#if 0
 /* ADSI Layer 2 transmission functions */
-extern int adsi_transmit_messages(struct ast_channel *chan, unsigned char **msg, int *msglen, int *msgtype);
-extern int adsi_transmit_message(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype);
-extern int adsi_transmit_message_full(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype, int dowait);
+int (*transmit_messages)(struct ast_channel *chan, unsigned char **msg, int *msglen, int *msgtype);
+#endif
+
+int (*transmit_message)(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype);
+int (*transmit_message_full)(struct ast_channel *chan, unsigned char *msg, int msglen, int msgtype, int dowait);
 /*! Read some encoded DTMF data.   */
 /*!
  * Returns number of bytes received
  */
-extern int adsi_read_encoded_dtmf(struct ast_channel *chan, unsigned char *buf, int maxlen);
+int (*read_encoded_dtmf)(struct ast_channel *chan, unsigned char *buf, int maxlen);
 
 /* ADSI Layer 3 creation functions */
 
@@ -183,14 +189,14 @@
  *
  */
 
-extern int adsi_connect_session(unsigned char *buf, unsigned char *fdn, int ver);
+int (*connect_session)(unsigned char *buf, unsigned char *fdn, int ver);
 
 /*! Build Query CPE ID of equipment */ 
 /*!
  *  Returns number of bytes added to message
  */
-extern int adsi_query_cpeid(unsigned char *buf);
-extern int adsi_query_cpeinfo(unsigned char *buf);
+int (*query_cpeid)(unsigned char *buf);
+int (*query_cpeinfo)(unsigned char *buf);
 
 /*! Get CPE ID from an attached ADSI compatible CPE. */
 /*!
@@ -198,9 +204,9 @@
  * or -1 on hangup, or 0 if there was no hangup but it failed to find the
  * device ID.  Returns to voice mode if "voice" is non-zero.
  */
-extern int adsi_get_cpeid(struct ast_channel *chan, unsigned char *cpeid, int voice);
+int (*get_cpeid)(struct ast_channel *chan, unsigned char *cpeid, int voice);
 
-extern int adsi_get_cpeinfo(struct ast_channel *chan, int *width, int *height, int *buttons, int voice);
+int (*get_cpeinfo)(struct ast_channel *chan, int *width, int *height, int *buttons, int voice);
 
 /*! Begin an ADSI script download */ 
 /*!
@@ -214,7 +220,7 @@
  *
  */
 
-extern int adsi_download_connect(unsigned char *buf, unsigned char *service, unsigned char *fdn, unsigned char *sec, int ver);
+int (*download_connect)(unsigned char *buf, unsigned char *service, unsigned char *fdn, unsigned char *sec, int ver);
 
 /*! Disconnects a running session */
 /*!
@@ -223,7 +229,7 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_disconnect_session(unsigned char *buf);
+int (*disconnect_session)(unsigned char *buf);
 
 /*! Disconnects (and hopefully saves) a downloaded script */
 /*!
@@ -232,7 +238,7 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_download_disconnect(unsigned char *buf);
+int (*download_disconnect)(unsigned char *buf);
 
 /*! Puts CPE in data mode... */
 /*!
@@ -241,9 +247,9 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_data_mode(unsigned char *buf);
-extern int adsi_clear_soft_keys(unsigned char *buf);
-extern int adsi_clear_screen(unsigned char *buf);
+int (*data_mode)(unsigned char *buf);
+int (*clear_soft_keys)(unsigned char *buf);
+int (*clear_screen)(unsigned char *buf);
 
 /*! Puts CPE in voice mode... */
 /*!
@@ -253,14 +259,14 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_voice_mode(unsigned char *buf, int when);
+int (*voice_mode)(unsigned char *buf, int when);
 
 /*! Returns non-zero if Channel does or might support ADSI */
 /*!
  * \param chan Channel to check
  *
  */
-extern int adsi_available(struct ast_channel *chan);
+int (*available)(struct ast_channel *chan);
 
 /*! Loads a line of info into the display */ 
 /*!
@@ -276,7 +282,7 @@
  *
  */
 
-extern int adsi_display(unsigned char *buf, int page, int line, int just, int wrap, unsigned char *col1, unsigned char *col2);
+int (*display)(unsigned char *buf, int page, int line, int just, int wrap, unsigned char *col1, unsigned char *col2);
 
 /*! Sets the current line and page */ 
 /*!
@@ -288,7 +294,7 @@
  *
  */
 
-extern int adsi_set_line(unsigned char *buf, int page, int line);
+int (*set_line)(unsigned char *buf, int page, int line);
 
 /*! Creates "load soft key" parameters */
 /*! 
@@ -302,7 +308,7 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_load_soft_key(unsigned char *buf, int key, unsigned char *llabel, unsigned char *slabel, unsigned char *ret, int data);
+int (*load_soft_key)(unsigned char *buf, int key, unsigned char *llabel, unsigned char *slabel, unsigned char *ret, int data);
 
 /*! Set which soft keys should be displayed */
 /*!
@@ -313,7 +319,7 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_set_keys(unsigned char *buf, unsigned char *keys);
+int (*set_keys)(unsigned char *buf, unsigned char *keys);
 
 /*! Set input information */
 /*!
@@ -327,7 +333,7 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_input_control(unsigned char *buf, int page, int line, int display, int format, int just);
+int (*input_control)(unsigned char *buf, int page, int line, int display, int format, int just);
 
 /*! Set input format */
 /*!
@@ -341,5 +347,6 @@
  * Returns number of bytes added to buffer or -1 on error.
  *
  */
-extern int adsi_input_format(unsigned char *buf, int num, int dir, int wrap, unsigned char *format1, unsigned char *format2);
+int (*input_format)(unsigned char *buf, int num, int dir, int wrap, unsigned char *format1, unsigned char *format2);
+};
 #endif
Index: include/asterisk/crypto.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/crypto.h,v
retrieving revision 1.6
diff -u -r1.6 crypto.h
--- include/asterisk/crypto.h	21 Apr 2005 06:02:44 -0000	1.6
+++ include/asterisk/crypto.h	25 May 2005 21:10:15 -0000
@@ -26,6 +26,7 @@
 
 struct ast_key;
 
+struct ast_crypto {
 /*! Retrieve a key */
 /*! 
  * \param name of the key we are retrieving
@@ -33,14 +34,16 @@
  *
  * Returns the key on success or NULL on failure
  */
-extern struct ast_key *ast_key_get(char *key, int type);
+struct ast_key *(*ast_key_get)(char *key, int type);
 
+#if 0
 /*! Initialize keys (that is, retrieve pass codes for all private keys) */
 /*!
  * \param fd a file descriptor for I/O for passwords
  *
  */
-extern int ast_key_init(int fd);
+int (*ast_key_init)(int fd);
+#endif
 
 /*! Check the authenticity of a message signature using a given public key */
 /*!
@@ -51,7 +54,7 @@
  * Returns 0 if the signature is valid, or -1 otherwise
  *
  */
-extern int ast_check_signature(struct ast_key *key, char *msg, char *sig);
+int (*ast_check_signature)(struct ast_key *key, char *msg, char *sig);
 
 /*! Check the authenticity of a message signature using a given public key */
 /*!
@@ -62,7 +65,7 @@
  * Returns 0 if the signature is valid, or -1 otherwise
  *
  */
-extern int ast_check_signature_bin(struct ast_key *key, char *msg, int msglen, unsigned char *sig);
+int (*ast_check_signature_bin)(struct ast_key *key, char *msg, int msglen, unsigned char *sig);
 
 /*!
  * \param key a private key to use to create the signature
@@ -73,7 +76,7 @@
  * Returns 0 on success or -1 on failure.
  *
  */
-extern int ast_sign(struct ast_key *key, char *msg, char *sig);
+int (*ast_sign)(struct ast_key *key, char *msg, char *sig);
 /*!
  * \param key a private key to use to create the signature
  * \param msg the message to sign
@@ -83,7 +86,7 @@
  * Returns 0 on success or -1 on failure.
  *
  */
-extern int ast_sign_bin(struct ast_key *key, char *msg, int msglen, unsigned char *sig);
+int (*ast_sign_bin)(struct ast_key *key, char *msg, int msglen, unsigned char *sig);
 
 /*!
  * \param key a private key to use to encrypt
@@ -95,7 +98,7 @@
  * Returns length of encrypted data on success or -1 on failure.
  *
  */
-extern int ast_encrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key);
+int (*ast_encrypt_bin)(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key);
 
 /*!
  * \param key a private key to use to decrypt
@@ -107,7 +110,9 @@
  * Returns length of decrypted data on success or -1 on failure.
  *
  */
-extern int ast_decrypt_bin(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key);
+int (*ast_decrypt_bin)(unsigned char *dst, const unsigned char *src, int srclen, struct ast_key *key);
+};
+
 #if defined(__cplusplus) || defined(c_plusplus)
 }
 #endif
Index: include/asterisk/features.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/features.h,v
retrieving revision 1.4
diff -u -r1.4 features.h
--- include/asterisk/features.h	15 Jan 2005 23:48:12 -0000	1.4
+++ include/asterisk/features.h	25 May 2005 21:10:15 -0000
@@ -17,6 +17,7 @@
 #ifndef _AST_FEATURES_H
 #define _AST_FEATURES_H
 
+struct ast_features {
 /*! Park a call and read back parked location */
 /*! \param chan the channel to actually be parked
     \param host the channel which will have the parked location read to
@@ -27,7 +28,7 @@
 	\param timeout is a timeout in milliseconds
 	\param extout is a parameter to an int that will hold the parked location, or NULL if you want
 */
-extern int ast_park_call(struct ast_channel *chan, struct ast_channel *host, int timeout, int *extout);
+int (*ast_park_call)(struct ast_channel *chan, struct ast_channel *host, int timeout, int *extout);
 /*! Park a call via a masqueraded channel */
 /*! \param rchan the real channel to be parked
     \param host the channel to have the parking read to
@@ -36,19 +37,19 @@
 	\param timeout is a timeout in milliseconds
 	\param extout is a parameter to an int that will hold the parked location, or NULL if you want
 */
-extern int ast_masq_park_call(struct ast_channel *rchan, struct ast_channel *host, int timeout, int *extout);
+int (*ast_masq_park_call)(struct ast_channel *rchan, struct ast_channel *host, int timeout, int *extout);
 
 /*! Determine system parking extension */
 /*! Returns the call parking extension for drivers that provide special
     call parking help */
-extern char *ast_parking_ext(void);
-extern char *ast_pickup_ext(void);
+char * (*ast_parking_ext)(void);
+char * (*ast_pickup_ext)(void);
 
 /*! Bridge a call, optionally allowing redirection */
 
-extern int ast_bridge_call(struct ast_channel *chan, struct ast_channel *peer,struct ast_bridge_config *config);
-
-extern int ast_pickup_call(struct ast_channel *chan);
+int (*ast_bridge_call)(struct ast_channel *chan, struct ast_channel *peer,struct ast_bridge_config *config);
 
+int (*ast_pickup_call)(struct ast_channel *chan);
+};
 
 #endif /* _AST_FEATURES_H */
